;;
;; 2018.11.21
;;
(define (que-std)
  (let
      ((seed  '())
       (ans   #f))
    (define (inque! x)
      (define (last p)
	(if (null? (cdr p)) p
	    (last (cdr p))))
      (if (null? seed) (set! seed (list x))
	  (let
	      ((p (last seed)))
	    (set-cdr! p (list x)))))
    (define (outque!)
      (if (null? seed) (set! ans #f)
	  (begin
	    (set! ans (car seed))
	    (set! seed (cdr seed)))))
    (define (show-drv p)
      (if (null? p) (newline)
	  (begin
	    (display (car p)) (display " ") (show-drv (cdr p)))))
;
    (define (dispatch m . arg)
      (cond
       ((eq? m 'inque!) (inque! (car arg)))
       ((eq? m 'outque!) (outque!) ans)
       ((eq? m 'show) (show-drv seed))
       ((eq? m 'isempty?) (null? seed))
       ((eq? m 'clear!) (set! seed '()))
       (else (display "ERR") (newline))))
    dispatch))
;

